#ifndef __AMSMATHUTIL25_AMSARRAY_SORTIMPL_HPP__
#define __AMSMATHUTIL25_AMSARRAY_SORTIMPL_HPP__

namespace ams
{


template<typename T> int amsarray_quicksort_round(
    amsarray<T> *array, 
    amsarray<amsarray_size_t> *permarray, 
    ams::pair<amsarray_size_t,amsarray_size_t> range,
    amsarray_size_t *pivot_index,
    ams::pair<amsarray_size_t,amsarray_size_t> *leftrange,
    ams::pair<amsarray_size_t,amsarray_size_t> *rightrange
)
{
    int ret = 0;
    bool b1,b2;
    amsarray_size_t I,J,P;
    T v1,v2;
    amsarray_size_t tmp;

    b1 = range.a < 0 || range.b < 0;
    b2 = (range.b - range.a) < 2;
    if((b1 || b2)
    {
        //there is no more work to be done within this range
        *pivot_index = -1;
        *leftrange = ams::pair<amsarray_size_t,amsarray_size_t>(-1,-1);
        *rightrange = ams::pair<amsarray_size_t,amsarray_size_t>(-1,-1);
        ret = -1;
        return ret;
    }
    if((range.b - range.a) == 2)
    {
        //two element range - sort directly
        v1 = array->data[permarray->data[range.a]];
        v2 = array->data[permarray->data[range.b]];
        if(v2<v1)
        {
            //swap permutation indices
            tmp = permarray->data[range.a];
            permarray->data[range.a] = permarray->data[range.b];
            permarray->data[range.b] = tmp;
        }
        //there is no more work to be done within this range
        *pivot_index = -1;
        *leftrange = ams::pair<amsarray_size_t,amsarray_size_t>(-1,-1);
        *rightrange = ams::pair<amsarray_size_t,amsarray_size_t>(-1,-1);
        ret = -1;
        return ret;
    }
    else
    {
        //perform quicksort iteration

        //choose midpoint pivot
        P = (range.a + range.b)/2;
        P = (P<range.a) ? range.a : P;
        P = (P>=range.b) ? range.b-1 : P;

        

    }




    return ret;
}


//returns an array of indices that is a permutation which will sort
//this array in ascending order
template<typename T> amsarray<amsarray_size_t> amsarray<T>::sort_permutation()
{
    int res;
    amsarray<amsarray_size_t> ret;

    return ret;
}





}; //end namespace ams

#endif

